diff --git a/contrib/spi/refint.c b/contrib/spi/refint.c
index f90f2bce0e..adf0490f85 100644
--- a/contrib/spi/refint.c
+++ b/contrib/spi/refint.c
@@ -473,9 +473,12 @@ check_foreign_key(PG_FUNCTION_ARGS)
 						nv = SPI_getvalue(newtuple, tupdesc, fn);
 						type = SPI_gettype(tupdesc, fn);
 
-						if ((strcmp(type, "text") && strcmp(type, "varchar") &&
-							 strcmp(type, "char") && strcmp(type, "bpchar") &&
-							 strcmp(type, "date") && strcmp(type, "timestamp")) == 0)
+						if (strcmp(type, "text") == 0 ||
+							strcmp(type, "varchar") == 0 ||
+							strcmp(type, "char") == 0 ||
+							strcmp(type, "bpchar") == 0 ||
+							strcmp(type, "date") == 0 ||
+							strcmp(type, "timestamp") == 0)
 							is_char_type = 1;
 #ifdef	DEBUG_QUERY
 						elog(DEBUG4, "check_foreign_key Debug value %s type %s %d",
diff --git a/src/backend/commands/lockcmds.c b/src/backend/commands/lockcmds.c
index df681e3234..97cf0bc4ad 100644
--- a/src/backend/commands/lockcmds.c
+++ b/src/backend/commands/lockcmds.c
@@ -219,7 +219,8 @@ LockViewRecurse_walker(Node *node, LockViewRecurse_context *context)
 			 * skipped.
 			 */
 			if (relid == context->viewoid &&
-				(!strcmp(rte->eref->aliasname, "old") || !strcmp(rte->eref->aliasname, "new")))
+				(strcmp(rte->eref->aliasname, "old") == 0 ||
+				 strcmp(rte->eref->aliasname, "new") == 0))
 				continue;
 
 			/* Currently, we only allow plain tables or views to be locked. */
diff --git a/src/test/modules/test_rls_hooks/test_rls_hooks.c b/src/test/modules/test_rls_hooks/test_rls_hooks.c
index 8bf8f764ac..10379bc59c 100644
--- a/src/test/modules/test_rls_hooks/test_rls_hooks.c
+++ b/src/test/modules/test_rls_hooks/test_rls_hooks.c
@@ -75,8 +75,8 @@ test_rls_hooks_permissive(CmdType cmdtype, Relation relation)
 	ParseState *qual_pstate;
 	RangeTblEntry *rte;
 
-	if (strcmp(RelationGetRelationName(relation), "rls_test_permissive")
-		&& strcmp(RelationGetRelationName(relation), "rls_test_both"))
+	if (strcmp(RelationGetRelationName(relation), "rls_test_permissive") != 0 &&
+		strcmp(RelationGetRelationName(relation), "rls_test_both") != 0)
 		return NIL;
 
 	qual_pstate = make_parsestate(NULL);
@@ -140,8 +140,8 @@ test_rls_hooks_restrictive(CmdType cmdtype, Relation relation)
 	RangeTblEntry *rte;
 
 
-	if (strcmp(RelationGetRelationName(relation), "rls_test_restrictive")
-		&& strcmp(RelationGetRelationName(relation), "rls_test_both"))
+	if (strcmp(RelationGetRelationName(relation), "rls_test_restrictive") != 0 &&
+		strcmp(RelationGetRelationName(relation), "rls_test_both") != 0)
 		return NIL;
 
 	qual_pstate = make_parsestate(NULL);
